# Generated by Django 2.0 on 2017-12-03 13:50

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import talos.models
import uuid


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('contenttypes', '0002_remove_content_type_name'),
    ]

    operations = [
        migrations.CreateModel(
            name='Principal',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('brief_name', models.CharField(blank=True, max_length=255)),
                ('full_name', models.CharField(blank=True, max_length=255)),
                ('email', models.EmailField(max_length=255, unique=True)),
                ('phone', models.CharField(blank=True, max_length=255, null=True, unique=True)),
                ('is_active', models.BooleanField(default=True)),
                ('last_login', models.DateTimeField(blank=True, null=True)),
                ('salt', models.BinaryField()),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Principal',
                'verbose_name_plural': 'Principals',
            },
        ),
        migrations.CreateModel(
            name='BasicCredential',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('valid_from', models.DateTimeField(default=talos.models._tznow)),
                ('valid_till', models.DateTimeField(default=talos.models._tzmax)),
                ('algorithm_name', models.CharField(choices=[('pbkdf2', 'pbkdf2'), ('bcrypt', 'bcrypt'), ('scrypt', 'scrypt')], default='pbkdf2', max_length=255)),
                ('algorithm_rounds', models.PositiveIntegerField(default=100000)),
                ('salt', models.BinaryField()),
                ('password_hmac', models.BinaryField()),
                ('force_change', models.BooleanField(default=False)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Basic Credential',
                'verbose_name_plural': 'Basic Credentials',
            },
        ),
        migrations.CreateModel(
            name='BasicCredentialDirectory',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('backend_class', models.CharField(max_length=255)),
                ('priority', models.PositiveIntegerField(default=1)),
                ('is_active', models.BooleanField(default=True)),
                ('code', models.SlugField(allow_unicode=True, max_length=255, unique=True)),
                ('name', models.CharField(max_length=255, unique=True)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Basic Credential Directory',
                'verbose_name_plural': 'Basic Credential Directories',
            },
        ),
        migrations.CreateModel(
            name='BasicCredentialDirectoryObjectPermission',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='BasicCredentialDirectoryOption',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('name', models.CharField(max_length=255)),
                ('value', models.TextField()),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('directory', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='options', to='talos.BasicCredentialDirectory')),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='BasicCredentialDirectoryProvidedEvidence',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('directory', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.BasicCredentialDirectory')),
            ],
            options={
                'verbose_name': 'Evidence Provided by Basic Credential Directory',
                'verbose_name_plural': 'Evidences Provided by Basic Credential Directory',
            },
        ),
        migrations.CreateModel(
            name='BasicIdentity',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('username', models.CharField(max_length=255)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Basic Identity',
                'verbose_name_plural': 'Basic Identities',
            },
        ),
        migrations.CreateModel(
            name='BasicIdentityDirectory',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('backend_class', models.CharField(max_length=255)),
                ('priority', models.PositiveIntegerField(default=1)),
                ('is_active', models.BooleanField(default=True)),
                ('code', models.SlugField(allow_unicode=True, max_length=255, unique=True)),
                ('name', models.CharField(max_length=255, unique=True)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('credential_directory', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='identity_directories', to='talos.BasicCredentialDirectory')),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Basic Identity Directory',
                'verbose_name_plural': 'Basic Identity Directories',
            },
        ),
        migrations.CreateModel(
            name='BasicIdentityDirectoryObjectPermission',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='BasicIdentityDirectoryOption',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('name', models.CharField(max_length=255)),
                ('value', models.TextField()),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('directory', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='options', to='talos.BasicIdentityDirectory')),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='Evidence',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('code', models.SlugField(allow_unicode=True, max_length=255, unique=True)),
                ('name', models.CharField(max_length=255, unique=True)),
                ('expiration_period', models.PositiveIntegerField(default=3600)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Evidence',
                'verbose_name_plural': 'Evidence',
            },
        ),
        migrations.CreateModel(
            name='ModelAction',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('application', models.CharField(max_length=255)),
                ('model', models.CharField(max_length=255)),
                ('action', models.CharField(max_length=255)),
                ('code', models.SlugField(allow_unicode=True, max_length=255, unique=True)),
                ('name', models.CharField(max_length=255, unique=True)),
                ('content_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='contenttypes.ContentType')),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Model Action',
                'verbose_name_plural': 'Model Actions',
            },
        ),
        migrations.CreateModel(
            name='ObjectAction',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('application', models.CharField(max_length=255)),
                ('model', models.CharField(max_length=255)),
                ('action', models.CharField(max_length=255)),
                ('code', models.SlugField(allow_unicode=True, max_length=255, unique=True)),
                ('name', models.CharField(max_length=255, unique=True)),
                ('content_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='contenttypes.ContentType')),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Object Action',
                'verbose_name_plural': 'Object Actions',
            },
        ),
        migrations.CreateModel(
            name='OneTimePasswordCredential',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('valid_from', models.DateTimeField(default=talos.models._tznow)),
                ('valid_till', models.DateTimeField(default=talos.models._tzmax)),
                ('salt', models.BinaryField()),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'One-Time Password Credential',
                'verbose_name_plural': 'One-Time Password Credentials',
            },
        ),
        migrations.CreateModel(
            name='OneTimePasswordCredentialDirectory',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('backend_class', models.CharField(max_length=255)),
                ('priority', models.PositiveIntegerField(default=1)),
                ('is_active', models.BooleanField(default=True)),
                ('code', models.SlugField(allow_unicode=True, max_length=255, unique=True)),
                ('name', models.CharField(max_length=255, unique=True)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'One-Time Password Credential Directory',
                'verbose_name_plural': 'One-Time Password Credential Directories',
            },
        ),
        migrations.CreateModel(
            name='OneTimePasswordCredentialDirectoryObjectPermission',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('action', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.ObjectAction')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='OneTimePasswordCredentialDirectoryOption',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('name', models.CharField(max_length=255)),
                ('value', models.TextField()),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('directory', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='options', to='talos.OneTimePasswordCredentialDirectory')),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='OneTimePasswordCredentialDirectoryProvidedEvidence',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('directory', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.OneTimePasswordCredentialDirectory')),
                ('evidence', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Evidence')),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Evidence Provided by One-Time Password Credential Directory',
                'verbose_name_plural': 'Evidences Provided by One-Time Password Credential Directory',
            },
        ),
        migrations.CreateModel(
            name='PrincipalObjectPermission',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('action', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.ObjectAction')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='PrincipalRoleMembership',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('principal', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Principal Membership',
                'verbose_name_plural': 'Principal Membership',
            },
        ),
        migrations.CreateModel(
            name='Privilege',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('code', models.SlugField(allow_unicode=True, max_length=255, unique=True)),
                ('name', models.CharField(max_length=255, unique=True)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Privilege',
                'verbose_name_plural': 'Privileges',
            },
        ),
        migrations.CreateModel(
            name='Realm',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('brief_name', models.CharField(blank=True, max_length=255)),
                ('full_name', models.CharField(blank=True, max_length=255)),
                ('email', models.EmailField(blank=True, max_length=255)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Realm',
                'verbose_name_plural': 'Realms',
            },
        ),
        migrations.CreateModel(
            name='Role',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('code', models.SlugField(allow_unicode=True, max_length=255, unique=True)),
                ('name', models.CharField(max_length=255, unique=True)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Role',
                'verbose_name_plural': 'Roles',
            },
        ),
        migrations.CreateModel(
            name='RoleDirectory',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('backend_class', models.CharField(max_length=255)),
                ('priority', models.PositiveIntegerField(default=1)),
                ('is_active', models.BooleanField(default=True)),
                ('code', models.SlugField(allow_unicode=True, max_length=255, unique=True)),
                ('name', models.CharField(max_length=255, unique=True)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Role Directory',
                'verbose_name_plural': 'Role Directories',
            },
        ),
        migrations.CreateModel(
            name='RoleDirectoryObjectPermission',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('action', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.ObjectAction')),
                ('role', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Role')),
                ('target', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='permissions', to='talos.RoleDirectory')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='RoleDirectoryOption',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('name', models.CharField(max_length=255)),
                ('value', models.TextField()),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('directory', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='options', to='talos.RoleDirectory')),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='RoleDirectoryRequiredEvidence',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('directory', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.RoleDirectory')),
                ('evidence', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Evidence')),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Evidence Required for Role Directory',
                'verbose_name_plural': 'Evidences Required for Role Directory',
            },
        ),
        migrations.CreateModel(
            name='RoleModelActionPermissionEffective',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('model_action', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.ModelAction')),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('role', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Role')),
            ],
            options={
                'verbose_name': 'Effective Model Action Permission of a Role',
                'verbose_name_plural': 'Effective Model Action Permissions of a Role',
            },
        ),
        migrations.CreateModel(
            name='RoleModelActionPermissionGranted',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('model_action', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.ModelAction')),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('role', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Role')),
            ],
            options={
                'verbose_name': 'Model Action Permission Granted to Role',
                'verbose_name_plural': 'Model Action Permissions Granted to Role',
            },
        ),
        migrations.CreateModel(
            name='RoleModelActionPermissionRevoked',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('model_action', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.ModelAction')),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('role', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Role')),
            ],
            options={
                'verbose_name': 'Model Action Permission Revoked from Role',
                'verbose_name_plural': 'Model Action Permissions Revoked from Role',
            },
        ),
        migrations.CreateModel(
            name='RoleObjectPermission',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('action', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.ObjectAction')),
                ('role', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Role')),
                ('target', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='permissions', to='talos.Role')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='RolePrivilegePermissionEffective',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('privilege', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Privilege')),
                ('role', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Role')),
            ],
            options={
                'verbose_name': 'Effective Privilege Permission of a Role',
                'verbose_name_plural': 'Effective Privilege Permissions of a Role',
            },
        ),
        migrations.CreateModel(
            name='RolePrivilegePermissionGranted',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('privilege', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Privilege')),
                ('role', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Role')),
            ],
            options={
                'verbose_name': 'Privilege Permission Granted to a Role',
                'verbose_name_plural': 'Privilege Permissions Granted to a Role',
            },
        ),
        migrations.CreateModel(
            name='RolePrivilegePermissionRevoked',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('privilege', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Privilege')),
                ('role', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Role')),
            ],
            options={
                'verbose_name': 'Privilege Permission Revoked from a Role',
                'verbose_name_plural': 'Privilege Permissions Revoked from a Role',
            },
        ),
        migrations.CreateModel(
            name='Session',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('valid_from', models.DateTimeField(default=talos.models._tznow)),
                ('valid_till', models.DateTimeField(default=talos.models._tzmax)),
                ('external_id', models.TextField(blank=True, null=True)),
                ('evidences', models.TextField(blank=True, null=True)),
                ('roles', models.TextField(blank=True, null=True)),
                ('privileges', models.TextField(blank=True, null=True)),
                ('model_actions', models.TextField(blank=True, null=True)),
                ('variables', models.TextField(blank=True, null=True)),
                ('remote_address', models.TextField(blank=True, null=True)),
                ('remote_geoname', models.TextField(blank=True, null=True)),
                ('remote_hw_family', models.CharField(blank=True, max_length=255, null=True)),
                ('remote_hw_model', models.CharField(blank=True, max_length=255, null=True)),
                ('remote_os_family', models.CharField(blank=True, max_length=255, null=True)),
                ('remote_os_version', models.CharField(blank=True, max_length=255, null=True)),
                ('remote_ua_family', models.CharField(blank=True, max_length=255, null=True)),
                ('remote_ua_version', models.CharField(blank=True, max_length=255, null=True)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('previous_session', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='talos.Session')),
                ('principal', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='sessions', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Session',
                'verbose_name_plural': 'Sessions',
            },
        ),
        migrations.CreateModel(
            name='SubnetCredential',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('valid_from', models.DateTimeField(default=talos.models._tznow)),
                ('valid_till', models.DateTimeField(default=talos.models._tzmax)),
                ('address', models.GenericIPAddressField()),
                ('network', models.PositiveIntegerField()),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Subnet Credential',
                'verbose_name_plural': 'Subnet Credentials',
            },
        ),
        migrations.CreateModel(
            name='SubnetCredentialDirectory',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('backend_class', models.CharField(max_length=255)),
                ('priority', models.PositiveIntegerField(default=1)),
                ('is_active', models.BooleanField(default=True)),
                ('code', models.SlugField(allow_unicode=True, max_length=255, unique=True)),
                ('name', models.CharField(max_length=255, unique=True)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Subnet Credential Directory',
                'verbose_name_plural': 'Subnet Credential Directories',
            },
        ),
        migrations.CreateModel(
            name='SubnetCredentialDirectoryObjectPermission',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('action', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.ObjectAction')),
                ('role', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Role')),
                ('target', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='permissions', to='talos.SubnetCredentialDirectory')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='SubnetCredentialDirectoryOption',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('name', models.CharField(max_length=255)),
                ('value', models.TextField()),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('directory', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='options', to='talos.SubnetCredentialDirectory')),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='SubnetCredentialDirectoryProvidedEvidence',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('directory', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.SubnetCredentialDirectory')),
                ('evidence', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Evidence')),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Evidence Provided by Subnet Credential Directory',
                'verbose_name_plural': 'Evidences Provided by Subnet Credential Directory',
            },
        ),
        migrations.CreateModel(
            name='TokenCredential',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('valid_from', models.DateTimeField(default=talos.models._tznow)),
                ('valid_till', models.DateTimeField(default=talos.models._tzmax)),
                ('public_value', models.CharField(max_length=255)),
                ('secret_value', models.CharField(max_length=255)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Token Credential',
                'verbose_name_plural': 'Token Credentials',
            },
        ),
        migrations.CreateModel(
            name='TokenCredentialDirectory',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('backend_class', models.CharField(max_length=255)),
                ('priority', models.PositiveIntegerField(default=1)),
                ('is_active', models.BooleanField(default=True)),
                ('code', models.SlugField(allow_unicode=True, max_length=255, unique=True)),
                ('name', models.CharField(max_length=255, unique=True)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Token Credential Directory',
                'verbose_name_plural': 'Token Credential Directories',
            },
        ),
        migrations.CreateModel(
            name='TokenCredentialDirectoryObjectPermission',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('action', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.ObjectAction')),
                ('role', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Role')),
                ('target', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='permissions', to='talos.TokenCredentialDirectory')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TokenCredentialDirectoryOption',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('name', models.CharField(max_length=255)),
                ('value', models.TextField()),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('directory', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='options', to='talos.TokenCredentialDirectory')),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='TokenCredentialDirectoryProvidedEvidence',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('directory', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.TokenCredentialDirectory')),
                ('evidence', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Evidence')),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Evidence Provided by Token Credential Directory',
                'verbose_name_plural': 'Evidences Provided by Token Credential Directory',
            },
        ),
        migrations.CreateModel(
            name='ValidationToken',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False, unique=True)),
                ('uuid', models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('modified_at', models.DateTimeField(auto_now=True)),
                ('created_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('modified_on', models.CharField(default=talos.models._default_hostname, max_length=255)),
                ('email', models.EmailField(editable=False, max_length=255)),
                ('type', models.CharField(choices=[('principal_registration', 'Principal registration'), ('password_reset', 'Password reset'), ('email_change', 'E-mail change')], editable=False, max_length=255)),
                ('secret', models.CharField(editable=False, max_length=64, unique=True)),
                ('expires_at', models.DateTimeField(editable=False)),
                ('is_active', models.BooleanField(default=True)),
                ('created_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('modified_by', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
                ('principal', models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'Validation Token',
                'verbose_name_plural': 'Validation Tokens',
            },
        ),
        migrations.AddField(
            model_name='tokencredentialdirectory',
            name='provided_evidences',
            field=models.ManyToManyField(related_name='_tokencredentialdirectory_provided_evidences_+', through='talos.TokenCredentialDirectoryProvidedEvidence', to='talos.Evidence'),
        ),
        migrations.AddField(
            model_name='tokencredential',
            name='directory',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='credentials', to='talos.TokenCredentialDirectory'),
        ),
        migrations.AddField(
            model_name='tokencredential',
            name='modified_by',
            field=models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='tokencredential',
            name='principal',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='subnetcredentialdirectory',
            name='provided_evidences',
            field=models.ManyToManyField(related_name='_subnetcredentialdirectory_provided_evidences_+', through='talos.SubnetCredentialDirectoryProvidedEvidence', to='talos.Evidence'),
        ),
        migrations.AddField(
            model_name='subnetcredential',
            name='directory',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='credentials', to='talos.SubnetCredentialDirectory'),
        ),
        migrations.AddField(
            model_name='subnetcredential',
            name='modified_by',
            field=models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='subnetcredential',
            name='principal',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='roledirectory',
            name='required_evidences',
            field=models.ManyToManyField(related_name='_roledirectory_required_evidences_+', through='talos.RoleDirectoryRequiredEvidence', to='talos.Evidence'),
        ),
        migrations.AddField(
            model_name='role',
            name='directory',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='roles', to='talos.RoleDirectory'),
        ),
        migrations.AddField(
            model_name='role',
            name='model_action_permissions_effective',
            field=models.ManyToManyField(related_name='_role_model_action_permissions_effective_+', through='talos.RoleModelActionPermissionEffective', to='talos.ModelAction'),
        ),
        migrations.AddField(
            model_name='role',
            name='model_action_permissions_granted',
            field=models.ManyToManyField(related_name='_role_model_action_permissions_granted_+', through='talos.RoleModelActionPermissionGranted', to='talos.ModelAction'),
        ),
        migrations.AddField(
            model_name='role',
            name='model_action_permissions_revoked',
            field=models.ManyToManyField(related_name='_role_model_action_permissions_revoked_+', through='talos.RoleModelActionPermissionRevoked', to='talos.ModelAction'),
        ),
        migrations.AddField(
            model_name='role',
            name='modified_by',
            field=models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='role',
            name='parent',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='children', to='talos.Role'),
        ),
        migrations.AddField(
            model_name='role',
            name='privilege_permissions_effective',
            field=models.ManyToManyField(related_name='_role_privilege_permissions_effective_+', through='talos.RolePrivilegePermissionEffective', to='talos.Privilege'),
        ),
        migrations.AddField(
            model_name='role',
            name='privilege_permissions_granted',
            field=models.ManyToManyField(related_name='_role_privilege_permissions_granted_+', through='talos.RolePrivilegePermissionGranted', to='talos.Privilege'),
        ),
        migrations.AddField(
            model_name='role',
            name='privilege_permissions_revoked',
            field=models.ManyToManyField(related_name='_role_privilege_permissions_revoked_+', through='talos.RolePrivilegePermissionRevoked', to='talos.Privilege'),
        ),
        migrations.AddField(
            model_name='principalrolemembership',
            name='role',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='principals', to='talos.Role'),
        ),
        migrations.AddField(
            model_name='principalobjectpermission',
            name='role',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Role'),
        ),
        migrations.AddField(
            model_name='principalobjectpermission',
            name='target',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='permissions', to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='onetimepasswordcredentialdirectoryobjectpermission',
            name='role',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Role'),
        ),
        migrations.AddField(
            model_name='onetimepasswordcredentialdirectoryobjectpermission',
            name='target',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='permissions', to='talos.OneTimePasswordCredentialDirectory'),
        ),
        migrations.AddField(
            model_name='onetimepasswordcredentialdirectory',
            name='provided_evidences',
            field=models.ManyToManyField(related_name='_onetimepasswordcredentialdirectory_provided_evidences_+', through='talos.OneTimePasswordCredentialDirectoryProvidedEvidence', to='talos.Evidence'),
        ),
        migrations.AddField(
            model_name='onetimepasswordcredential',
            name='directory',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='credentials', to='talos.OneTimePasswordCredentialDirectory'),
        ),
        migrations.AddField(
            model_name='onetimepasswordcredential',
            name='modified_by',
            field=models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='onetimepasswordcredential',
            name='principal',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='basicidentitydirectoryobjectpermission',
            name='action',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.ObjectAction'),
        ),
        migrations.AddField(
            model_name='basicidentitydirectoryobjectpermission',
            name='role',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Role'),
        ),
        migrations.AddField(
            model_name='basicidentitydirectoryobjectpermission',
            name='target',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='permissions', to='talos.BasicIdentityDirectory'),
        ),
        migrations.AddField(
            model_name='basicidentitydirectory',
            name='realm',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Realm'),
        ),
        migrations.AddField(
            model_name='basicidentity',
            name='directory',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='identities', to='talos.BasicIdentityDirectory'),
        ),
        migrations.AddField(
            model_name='basicidentity',
            name='modified_by',
            field=models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='basicidentity',
            name='principal',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='basiccredentialdirectoryprovidedevidence',
            name='evidence',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Evidence'),
        ),
        migrations.AddField(
            model_name='basiccredentialdirectoryprovidedevidence',
            name='modified_by',
            field=models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='basiccredentialdirectoryobjectpermission',
            name='action',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.ObjectAction'),
        ),
        migrations.AddField(
            model_name='basiccredentialdirectoryobjectpermission',
            name='role',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to='talos.Role'),
        ),
        migrations.AddField(
            model_name='basiccredentialdirectoryobjectpermission',
            name='target',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='permissions', to='talos.BasicCredentialDirectory'),
        ),
        migrations.AddField(
            model_name='basiccredentialdirectory',
            name='provided_evidences',
            field=models.ManyToManyField(related_name='_basiccredentialdirectory_provided_evidences_+', through='talos.BasicCredentialDirectoryProvidedEvidence', to='talos.Evidence'),
        ),
        migrations.AddField(
            model_name='basiccredential',
            name='directory',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='credentials', to='talos.BasicCredentialDirectory'),
        ),
        migrations.AddField(
            model_name='basiccredential',
            name='modified_by',
            field=models.ForeignKey(blank=True, editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='basiccredential',
            name='principal',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='+', to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='principal',
            name='roles',
            field=models.ManyToManyField(through='talos.PrincipalRoleMembership', to='talos.Role'),
        ),
        migrations.AlterUniqueTogether(
            name='tokencredentialdirectoryobjectpermission',
            unique_together={('role', 'action', 'target')},
        ),
        migrations.AlterIndexTogether(
            name='tokencredentialdirectoryobjectpermission',
            index_together={('target', 'action', 'role'), ('target', 'role', 'action'), ('role', 'target', 'action')},
        ),
        migrations.AlterUniqueTogether(
            name='tokencredential',
            unique_together={('directory', 'public_value'), ('directory', 'principal')},
        ),
        migrations.AlterUniqueTogether(
            name='subnetcredentialdirectoryobjectpermission',
            unique_together={('role', 'action', 'target')},
        ),
        migrations.AlterIndexTogether(
            name='subnetcredentialdirectoryobjectpermission',
            index_together={('target', 'action', 'role'), ('target', 'role', 'action'), ('role', 'target', 'action')},
        ),
        migrations.AlterUniqueTogether(
            name='subnetcredential',
            unique_together={('directory', 'address')},
        ),
        migrations.AlterUniqueTogether(
            name='roleprivilegepermissionrevoked',
            unique_together={('role', 'privilege')},
        ),
        migrations.AlterIndexTogether(
            name='roleprivilegepermissionrevoked',
            index_together={('privilege', 'role')},
        ),
        migrations.AlterUniqueTogether(
            name='roleprivilegepermissiongranted',
            unique_together={('role', 'privilege')},
        ),
        migrations.AlterIndexTogether(
            name='roleprivilegepermissiongranted',
            index_together={('privilege', 'role')},
        ),
        migrations.AlterUniqueTogether(
            name='roleprivilegepermissioneffective',
            unique_together={('role', 'privilege')},
        ),
        migrations.AlterIndexTogether(
            name='roleprivilegepermissioneffective',
            index_together={('privilege', 'role')},
        ),
        migrations.AlterUniqueTogether(
            name='roleobjectpermission',
            unique_together={('role', 'action', 'target')},
        ),
        migrations.AlterIndexTogether(
            name='roleobjectpermission',
            index_together={('target', 'action', 'role'), ('target', 'role', 'action'), ('role', 'target', 'action')},
        ),
        migrations.AlterUniqueTogether(
            name='rolemodelactionpermissionrevoked',
            unique_together={('role', 'model_action')},
        ),
        migrations.AlterIndexTogether(
            name='rolemodelactionpermissionrevoked',
            index_together={('model_action', 'role')},
        ),
        migrations.AlterUniqueTogether(
            name='rolemodelactionpermissiongranted',
            unique_together={('role', 'model_action')},
        ),
        migrations.AlterIndexTogether(
            name='rolemodelactionpermissiongranted',
            index_together={('model_action', 'role')},
        ),
        migrations.AlterUniqueTogether(
            name='rolemodelactionpermissioneffective',
            unique_together={('role', 'model_action')},
        ),
        migrations.AlterIndexTogether(
            name='rolemodelactionpermissioneffective',
            index_together={('model_action', 'role')},
        ),
        migrations.AlterUniqueTogether(
            name='roledirectoryrequiredevidence',
            unique_together={('directory', 'evidence')},
        ),
        migrations.AlterUniqueTogether(
            name='roledirectoryoption',
            unique_together={('directory', 'name')},
        ),
        migrations.AlterUniqueTogether(
            name='roledirectoryobjectpermission',
            unique_together={('role', 'action', 'target')},
        ),
        migrations.AlterIndexTogether(
            name='roledirectoryobjectpermission',
            index_together={('target', 'action', 'role'), ('target', 'role', 'action'), ('role', 'target', 'action')},
        ),
        migrations.AlterUniqueTogether(
            name='role',
            unique_together={('directory', 'name'), ('directory', 'code')},
        ),
        migrations.AlterUniqueTogether(
            name='principalrolemembership',
            unique_together={('principal', 'role')},
        ),
        migrations.AlterIndexTogether(
            name='principalrolemembership',
            index_together={('role', 'principal')},
        ),
        migrations.AlterUniqueTogether(
            name='principalobjectpermission',
            unique_together={('role', 'action', 'target')},
        ),
        migrations.AlterIndexTogether(
            name='principalobjectpermission',
            index_together={('target', 'action', 'role'), ('target', 'role', 'action'), ('role', 'target', 'action')},
        ),
        migrations.AlterUniqueTogether(
            name='onetimepasswordcredentialdirectoryobjectpermission',
            unique_together={('role', 'action', 'target')},
        ),
        migrations.AlterIndexTogether(
            name='onetimepasswordcredentialdirectoryobjectpermission',
            index_together={('target', 'action', 'role'), ('target', 'role', 'action'), ('role', 'target', 'action')},
        ),
        migrations.AlterUniqueTogether(
            name='onetimepasswordcredential',
            unique_together={('directory', 'principal')},
        ),
        migrations.AlterUniqueTogether(
            name='objectaction',
            unique_together={('application', 'model', 'action'), ('content_type', 'action')},
        ),
        migrations.AlterUniqueTogether(
            name='basicidentitydirectoryobjectpermission',
            unique_together={('role', 'action', 'target')},
        ),
        migrations.AlterIndexTogether(
            name='basicidentitydirectoryobjectpermission',
            index_together={('target', 'action', 'role'), ('target', 'role', 'action'), ('role', 'target', 'action')},
        ),
        migrations.AlterUniqueTogether(
            name='basicidentity',
            unique_together={('directory', 'username')},
        ),
        migrations.AlterUniqueTogether(
            name='basiccredentialdirectoryobjectpermission',
            unique_together={('role', 'action', 'target')},
        ),
        migrations.AlterIndexTogether(
            name='basiccredentialdirectoryobjectpermission',
            index_together={('target', 'action', 'role'), ('target', 'role', 'action'), ('role', 'target', 'action')},
        ),
        migrations.AlterUniqueTogether(
            name='basiccredential',
            unique_together={('directory', 'principal')},
        ),
    ]
